%define version 2.4.16C5_III

Summary: Cobalt x86 kernel 
Name: kernel
Version: 2.4.16C5_III
Release: 1
License: GPL
Group: Base/Kernel
ExclusiveOS: Linux
URL: http://www.kernel.org
Source: cobalt-linux-%{version}.tar.gz
BuildRoot: /home/tmp/kernel

%changelog
* Thu Dec 06 2001 Duncan Laurie <void@sun.com>
   - 2.4.16 merge

* Thu Oct 11 2001 Duncan Laurie <void@sun.com>
   - 2.4.12 merge
   - 2.4.11 was a "sorry excuse for a kernel" according to Linus
   - remove Makefile.in.prepend -- was removed from XFS patch?

* Tue Oct 02 2001 Tim Hockin <thockin@sun.com>
   - 2.4.10 merge

* Tue Jun 26 2001 Tim Hockin <thockin@sun.com>
   - made NVRAM code (Erik) be more generic
  
* Wed May 30 2001 Duncan Laurie <duncan.laurie@sun.com>
   - support for fixed scsi IDs
   - fix bugs in scsi.c and scsi_proc.c

* Tue May 29 2001 Tim Hockin <thockin@sun.com>
   - 2.4.5 import

* Fri May 04 2001 Tim Hockin <thockin@sun.com>
   - 2.4.4C1-6 build 

* Mon Apr 30 2001 Tim Hockin <thockin@sun.com>
   - 2.4.4 merge 

* Tue Apr 24 2001 Tim Hockin <thockin@sun.com>
   - make an SMP kernel build

* Fri Apr 13 2001 Tim Hockin <thockin@sun.com>
   - LED APIs in
   - LEDs working
   - Drive sleds working
   - halt.reboot working
   - ECC working
   - PCI bus speed specification working
   - released linux-2.4.3C1-1

* Wed Apr 11 2001 Tim Hockin <thockin@sun.com>
   - continued port to 2.4.x
   - specfile now does natsemi, rather than dp83815 for module conf

* Thu Mar 08 2001 Tim Hockin <thockin@sun.com>
   - partial port to 2.4.x

* Tue Oct 10 2000 Duncan Laurie <duncan@cobalt.com>
   - build for RaQ XTR

* Mon Sep 18 2000 Chris Johnson <cjohnson@cobalt.com>
   - More cleanup on %post below.  Deal with stale kernels
     by assuming "Intel Unknown" means eepro100.
   - Minor tweaks to fix debugging/watchdog interaction
* Wed Sep 13 2000 Adrian Sun
   - build with chris' really fixed eepro driver. 

* Wed Sep 13 2000 Tim Hockin
   - Fixup %post shell boolean associativity
   - Only alias ethernet modules that are eepro100 or dp83815
   - Detect DP83815 or NS Unknown as dp83815

* Tue Sep 12 2000 Chris Johnson <cjohnson@cobalt.com>
   - New Eepro driver and interrupt model to fix network behaviour under
     heavy load
   - Enabled many USB modules - just in case.
   - Converted ethernet drivers to modules.  RPM specfile (below)
     ensures that /etc/conf.modules is correct.
   - Fixed pci list for Nat-Semi driver so it is no longer "Unknown"
     Fixed Nat-Semi driver to use (new) values from pci.h

* Mon Aug 21 2000 Adrian Sun <asun@cobalt.com>
  - reiserfs-3.5.24 integration.
  - make separate reiserfs util rpm.

* Fri Jun 23 2000 Tim Hockin <thockin@cobalt.com>
  - 2.2.16 merge

* Thu Jun 08 2000 Tim Hockin <thockin@cobalt.com>
  - 2.2.16 security fix for setuid
    (kernel/capability.c, include/linux/capability.h, fs/exec.c)

* Thu May 18 2000 Tim Hockin <thockin@cobalt.com>
  - 2.2.15 merge

* Wed May 10 2000 Tim Hockin <thockin@cobalt.com>
  - Merged National dp83815 enet driver plus support code plus fixes

* Thu Apr 6 2000 Chris Johnson <cjohnson@cobalt.com>
  - Merged in UDP IPMASQ fix from 2.2.15pre17

  - Merged in all small/obvious fixes from 2.2.15pre17
    Lots of lock cleanup and error edge conditions.

* Sun Mar 26 2000 Chris Johnson <cjohnson@cobalt.com>
 - Added enable/disable feature to watchdog for insmod to
   prevent long duration device initialization from resetting
   the system.

 - Added NAT related config flags.

 - Added "cobalt_install" target to makefile.  Use with caution.

* Mon Mar  6 2000 Chris Johnson <cjohnson@cobalt.com>
 - Minor tweaks for bandwidth management linking.
 - Supports kgdb patch.

* Thu Jan 13 2000 Tim Hockin <thockin@cobalt.com>
 - Lots of various fixes have gone in here - no one has updated this file
 - 2.2.14 merge
 - Added RAID0145 patch
 - Added RAID-wo patch
 - Added USB patch
 - added patches to unofficial-patches dir
 - Everyone should remember to update the kernel.spec.in for big changes
 
* Tue Oct 05 1999 Tim Hockin <thockin@cobaltnet.com>
 - Fix for WDT when booted from ROM or net

* Mon Oct 04 1999 Tim Hockin <thockin@cobaltnet.com>
 - Fixes for WDT
 - Temperature is now output in /proc/cpuinfo
 - bwmgmt fixes for tcpdump from Chris
 - make rpm is smarter about versions, now
 - fixed (workaround, really) bug on first read of LM77

* Sun Oct 03 1999 Tim Hockin <thockin@cobaltnet.com>

 - New boards will have a builtin PIC - use that so we can ditch the PIC
    - hopefully this code can be scrapped - it's ugly
 - Added test for 82559ER - do not use MMIO!

* Tue Sep 28 1999 Tim Hockin <thockin@cobaltnet.com>

 - New cobalt_temp driver - gives /proc/cpu_temperature
 - version cleanups
 - WDT cleanup/enable
 - minor LED cleanup

* Tue Sep 14 1999 Tim Hockin <thockin@cobaltnet.com>

 - LCD driver cleanup by asun
 - New cobalt_wdt driver
 - Various cleanups, fixes, etc

* Thu Aug 26 1999 Tim Hockin <thockin@cobaltnet.com>

 - Patched up to 2.2.12
 - Backed out UDMA and kgdb patches
 - Versioning changed to match mips style
 - Changed tarfile name for $Source

* Tue Aug 24 1999 Timothy Stonis <tim@cobaltnet.com>

 - Added BW management stuff... 
 - Fix date on last checkin.  

* Wed Aug 18 1999 Timothy Stonis <tim@cobaltnet.com>

 - Roll in fix to IP aliasing 

* Sun Aug 8 1999 Timothy Stonis <tim@cobaltnet.com>

 - initial creation of Intel 2.2 package

%package headers
Summary: Header files for the Linux kernel.
Group: Base/Kernel

%package source
Summary: Kernel source tree
Group: Base/Kernel

%description
This package contains the Linux kernel and modules that are used to boot 
and run your system. The kernel contains a few device drivers for specific 
hardware, but most hardware is instead supported by modules loaded after 
booting.

%description source
This is the source code for the Linux kernel. It is required to build
most C programs as they depend on constants defined in here. You can
also build a custom kernel that is better tuned to your particular
hardware.

%description headers
These are the C header files for the Linux kernel, which define structures
and constants that are needed when building most standard programs under
Linux, as well as to rebuild the kernel.

%prep
if [ -n "$RPM_BUILD_ROOT" ]; then
    rm -rf $RPM_BUILD_ROOT
fi
mkdir -p $RPM_BUILD_ROOT
%setup -c -q

%build
# build the actual kernel
cd linux-%{version}
# 'make rpm' leaves $CONFIGURATION around - bad news
[ -n "$CONFIGURATION" ] && unset CONFIGURATION
make cobalt-dep clean COBALT_GENERATION=III
make cobalt COBALT_GENERATION=III
make modules COBALT_GENERATION=III

%install
# install the kernel we just built
cd linux-%{version}

# /boot files
mkdir -p $RPM_BUILD_ROOT/boot
cp vmlinux.gz $RPM_BUILD_ROOT/boot/vmlinux-%{version}.gz
ln -sf vmlinux-%{version}.gz $RPM_BUILD_ROOT/boot/vmlinux.gz
cp vmlinux.bz2 $RPM_BUILD_ROOT/boot/vmlinux-%{version}.bz2
ln -sf vmlinux-%{version}.bz2 $RPM_BUILD_ROOT/boot/vmlinux.bz2
cp System.map $RPM_BUILD_ROOT/boot/System-%{version}.map
ln -sf System-%{version}.map $RPM_BUILD_ROOT/boot/System.map
chmod 644 $RPM_BUILD_ROOT/boot/*
chown root.root $RPM_BUILD_ROOT/boot/*

# modules
mkdir -p -m 755 $RPM_BUILD_ROOT/lib/modules/%{version}
make modules_install INSTALL_MOD_PATH=$RPM_BUILD_ROOT \
	COBALT_GENERATION=III

# the sources
mkdir -p $RPM_BUILD_ROOT/usr/src/
cd $RPM_BUILD_ROOT/usr/src
# %{S:0} expands to the Source: line in the header
zcat %{S:0} | tar -xf-
ln -sfn linux-%{version} linux
chown -R root.root linux-%{version}

# make the sources ready for inclusion in the RPM
cd linux-%{version}
cat config-cobalt-III > .config
make oldconfig COBALT_GENERATION=III
make include/linux/version.h COBALT_GENERATION=III
echo COBALT_GENERATION=III > .cobalt_generation

# copy the header files into usr/include
mkdir -p $RPM_BUILD_ROOT/usr/include/asm
mkdir -p $RPM_BUILD_ROOT/usr/include/linux
cp -a include/asm/* $RPM_BUILD_ROOT/usr/include/asm
cp -a include/linux/* $RPM_BUILD_ROOT/usr/include/linux
chown -R root.root $RPM_BUILD_ROOT/usr/include/
find $RPM_BUILD_ROOT/usr/include/ -type d | xargs chmod 755
find $RPM_BUILD_ROOT/usr/include/ -type f | xargs chmod 644
# for compatibility
ln -s cobalt-lcd.h $RPM_BUILD_ROOT/usr/include/linux/lcd.h

# make a default /etc/modules.conf
mkdir -p $RPM_BUILD_ROOT/etc
touch $RPM_BUILD_ROOT/etc/modules.conf
chmod 644 $RPM_BUILD_ROOT/etc/modules.conf
cat > $RPM_BUILD_ROOT/etc/modules.conf << END
# for the Cobalt Bandwidth Manager
alias bandwidth_mgr bwmgmt

# the default scsi adapter to look for when SCSI devices are requested
alias scsi_hostadapter off

# the default network card to look for in the PCI slot
alias eth2 off

# the default sound card to look for in the PCI slot
alias sound sound-slot-0
alias sound-slot-0 off 

# BSD compression for PPP
alias ppp-compress-21 bsd_comp

# Appletalk, as known by Linux
alias net-pf-5 appletalk

# PPP
alias ppp0 ppp
probeall ppp ppp_async ppp_synctty

# USB 
probeall usb usb-ohci usb-uhci

# items to disable
alias char-major-4 off
alias net-pf-4 off
alias ppp-compress-24 off
alias ppp-compress-26 off
END

%clean
rm -rf $RPM_BUILD_ROOT

%pre
# nothing

%post
CONF_FILE=/etc/modules.conf
OLD_CONF=/etc/conf.modules
if [ -f $OLD_CONF ]; then
    if [ ! -f $CONF_FILE ]; then
        mv $OLD_CONF $CONF_FILE
    else
        echo "warning: $OLD_CONF exists, $CONF_FILE has superceded it"
    fi
fi

# Add lines for eth0 and eth1, if they seem to be missing
if [ ! -f $CONF_FILE ] || [ -z "`grep eth0 $CONF_FILE 2>/dev/null`" ]; then
	awk ' /Bus/   { getline ;
			if ($1 == "Ethernet" || ($2 ~ "0200")) {
			    etype=0;
			    if (($4 ~ "8255[789].*") || 
			     ($5 ~ "8255[789].*") || 
			     ($2 ~ "0200" && $5 ~ "8086") ||
			     ($3 ~ "Intel" && $5 ~ "Unknown") ||
			     ($3 ~ "Intel" && $4 ~ "Unknown")) {
				etype="eepro100";
			    } else if (($0 ~ "83815") || 
		             ($2 ~ "0200" && $5 ~ "100b") ||
			     ($3 ~ "NS" && $4 ~ "Unknown")) {
				etype="natsemi";
			    }   
			    if (etype) {
			    	printf "alias eth%d %s\n", ethnum, etype;
			    }
			    ethnum++;
			    if (ethnum > 1)
				exit
			}       
		} ' < /proc/pci >> $CONF_FILE
fi

# re-create /dev/lcd with the correct device number, JIC
rm -f /dev/lcd
mknod /dev/lcd c 10 156
chown root.httpd /dev/lcd
chmod 660 /dev/lcd

# make /dev/nvram, if needed
[ -c /dev/nvram ] || mknod /dev/nvram c 10 144
chmod 640 /dev/nvram

# make /dev/mtd0 and /dev/mtdr0, if needed
[ -c /dev/mtd0 ] || mknod /dev/mtd0 c 90 0
[ -c /dev/mtdr0 ] || mknod /dev/mtdr0 c 90 1
chmod 640 /dev/mtd0
chmod 640 /dev/mtdr0

# make /dev/i2c*, if needed
[ -c /dev/i2c-0 ] || mknod /dev/i2c-0 c 89 0
chmod 640 /dev/i2c-0
[ -c /dev/i2c-1 ] || mknod /dev/i2c-1 c 89 1
chmod 640 /dev/i2c-1

[ -x /sbin/depmod ] && /sbin/depmod -ae -F /boot/System-%{version}.map %{version}

%files
/boot/vmlinux-%{version}.gz
/boot/vmlinux-%{version}.bz2
/boot/vmlinux.gz
/boot/vmlinux.bz2
/boot/System-%{version}.map
/boot/System.map
/lib/modules/%{version}
%config(noreplace) /etc/modules.conf

%files source
/usr/src/linux
%dir /usr/src/linux-%{version}
/usr/src/linux-%{version}/.cobalt_generation
/usr/src/linux-%{version}/.config
/usr/src/linux-%{version}/COPYING
/usr/src/linux-%{version}/CREDITS
/usr/src/linux-%{version}/Documentation
/usr/src/linux-%{version}/MAINTAINERS
/usr/src/linux-%{version}/Makefile
/usr/src/linux-%{version}/Makefile.in.append
/usr/src/linux-%{version}/README
/usr/src/linux-%{version}/REPORTING-BUGS
/usr/src/linux-%{version}/Rules.make
/usr/src/linux-%{version}/arch
/usr/src/linux-%{version}/config-cobalt-*
/usr/src/linux-%{version}/drivers
/usr/src/linux-%{version}/fs
/usr/src/linux-%{version}/include
/usr/src/linux-%{version}/init
/usr/src/linux-%{version}/ipc
/usr/src/linux-%{version}/kdb
/usr/src/linux-%{version}/kernel
/usr/src/linux-%{version}/kernel.spec.in
/usr/src/linux-%{version}/lib
/usr/src/linux-%{version}/mm
/usr/src/linux-%{version}/net
/usr/src/linux-%{version}/scripts

%files headers
/usr/include/linux
/usr/include/asm
